User Interface - Bug #4826

HTTP 413 error with Web Client
07/29/2020 03:45 PM - Igor Skornyakov

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Sergey Ivanovskiy % Done: 100%
Category: Estimated time: 0.00 hour

Target version:

billable: No case_hum:
vendor_id: GCD version:
Description

History

#1 - 07/29/2020 03:50 PM - Igor Skornyakov

After multiple logins to Web Client | got the HTTP 413 Payload Too Large response on the OS login.
| understand that this is due to a huge number of cookies the browser attempts to send.
| use Google Chrome Version 81.0.4044.138 (Official Build) unknown (64-bit)

Cookie: Auth-bafb762d-e016-4a6e-bfb6-fal3c00c3a95=d0£959879a08dc3a23a44ffdeadbbfbd5083096a; Auth-0ca62c0a-7320
—-45a6-b5al-76d5415a8d8a=735436dabb7d404d4e7897b6c52838dade620462; Auth-002752f0-3cdb-415e-ba56-£7608797dc6d=2a
e9%9e3db9c5d2abafa6c77d017b903eb9d00915a; Auth-79bllead-91b8-4a8d-873f-5e82a1d64f3a=7c713ad0831784680ac8b60c3bda
£f5f0e9a8e48f; Auth-c45b685d-394e-4301-a%bd-6bfa7d6a890c=50d25df%e53a52dfcefa65£8686fa25d4974£0c6; Auth-ec35bd8
3-b732-4c0e-b1d0-d4b6a3e283e2=cl6f6bd610b652e0a2cdfa86£19c523035158ced; Auth-061e007b-d2ad-4b0f-ab50-eb54e058e
487=264d91bd4a3clbe97ed50a6abba68lfecal9e29f; Auth-7b9%9al419-5b2b-4b57-b5ad-1f08554db5b2=3a63bc47acbd0a70acfb71
cc37176a8b541d31b9; Auth-7fa2365b-29ec-4aa9-93bd-7738b83361led=1cdaaeb749b55c46e8ee2382797ade61e3041100; Auth-6
9002ddf-b5ec-444a-b532-493af415be32=p12£7919ced43e7491572240574533e36d363ec8b; Auth-a5bfled8-6f05-49b8-bae9-31d
111£f29434=8a0ea76749f3cbe78e064b8d87cbcc687bf0ec26; Auth-849al1444-4cb3-429f-8e67-e4abd6826c0f=2ceb5250df9e1402
c493fa048d5aa8l5ecee5772; Auth-£336346b-307e-49cc-9142-6a550b0b052c=a7e52c05de3b573c£3142a830959e38c565174dd;

Auth-61db4a70-ebed-4bb8-93d9-ddf24d5d34a5=e037ed5¢c402660a0a783369068£4d33ac800a969; Auth-70f£14dc-0298-4c33-b7
c8-ba2bfd402d30=77b8fd67e2b129ee5443c5a9f648271ac56ael09; Auth-91f26a19-998c-4d9f-849f-5068ec20d463=abc8dff9dc
9d12£fe7b7db50c054207647550991e; Auth-705a6f£62-bb41-45cb-89d5-a51747£89f91=0feelbl38bbbl164a2759ed925032c80e1563
08e7; Auth-152c7eae-2688-4c7c-a010-bc8clea2e421=d028b232749720d5£3a503795ec100707ad5645e; Auth-201b222b-74b8-4
b7c-bbfl-7cb031af2d18=2989d50621416£95e92fc333fal965080aec3aad; Auth-12982901-24e3-47dd-afbb-c7519bb608db=8abb
81e49a08e8b2f050cc2c4a56918f97cc68c6b; Auth-daB893133-749b-438f-alld-ab0e9479975a=7e5751fac7286ea7bl266b491e337c
30acc29cee; Auth-50fda484-3272-4c3a-bl42-1fdc3aabb77d=693637df8ba4623000548890622b28fec739%9a5c3; Auth-04d54cdc-
ef36-4928-85d6-7al5c0b8b522=fde698c9dcab6lf8ba8laz250a76d2a59f84ef179%; Auth-bb40b414-8535-4165-ae34-cd43df25£d6
d=232a268e10026238f78c48ed7bd708228f3fe50d; Auth-4acd8c67-30£fa-4910-a052-afc4590b5357=1b63051£f2cbl177c8b3c31cb5a
0da8cdb8elfd3lad; Auth-009%aab8a-deel-49f3-aa38-9e334b4aB8ed4c=4a5948176448a205892748cd083f2fc415643e73; Auth-871
a7698-d110-4788-9031-£fef55e4b0595=1560dbc47af5b21ffb8d4£f9a5£6e2908c8e806a4; Auth-7fclb08c-d74f-41d2-8a51-e3955
561a23c=e84a3878bb6ad0221d730d1df1124ad4b719f8ab; Auth-b6l6fcla-4e8f-4dde-aled-£854430£0339=1490a289222da9%fab52
5c44233e5e2894752589cf; Auth-1fl2ebd6-5547-416a-a85c-674d39f99b7a=7b5aca7c513e5fec4e8b051£fb48bfl4a29f4dbld; Au
th-cf70c070-bcd44-415b-abcd-3c291b45¢c9ff=c9d429f27cade941ca2305fec4d254d1d9435262; Auth-ca78a9fb-c4c5-416c-8610
-f8b101e79e84=8fledle6d67691a30cle5f5fdefb22302£34b66d; Auth-dblaa9ba-6af5-4532-9a35-4e553e3ea7e9=093a836985cc
e9b84312e26£88381eb950elc3£f5; Auth-1721030d-875c-4d2c-aal6-8abacf9acc73=5d7e930a6a29%9eded736862a8c09bdd2ec39e43
aa; Auth-5d85f476-8dcl-4939-baf9-8d5b83ce34fd=0cbbeb4992652bbf3dbb9c6ad663a72f23b032a9; Auth-98e11356-8301-439
7-a55b—-9ecf7521£95c=e4e1d6210a52f1bf575c20e0£d98e9d801e5e5ca; Auth-2677878d-6df5-40dd-8bl6-e6af67960325=6be501
a0fe7b7e50947ee9b£6d5287050b6d4c7b; Auth-9bcl0345-b9db-4b02-be3a-4e7ce917484c=07e4e5029821cdle7aefel3d2cbac2ce’
ab33c2db; Auth-1dal04b2c-65f1-44db-8941-40£0435624e9=0£fcb368c210ac7ac5dc26cbd7cf3£5£14b695018; Auth-f5dc2fd4-91
b0-4fe5-bb25-b5a26d507890=587c93badccdaec0f99cdc84ec0£fd35ae7667913; Auth-2e5cc0c7-8eae-459c-a9%6b-018773aebba8=
0c56953cc46d7b92c6744339769026564172d986; Auth-d4a5c98b-2d68-4a38-94c7-0206f142e466=4acf62bfadbc08795961531cfd
56c824559fc591; Auth-b75982e8-5920-4554-88aa-43307d437d26=79db253bea7192cc3cd49a0fcdl56al19e502246d; Auth-eadl5
775-ab70-46e6-ac2a-c5b0eae62739=e2ca9582102f74de341b4b2£d956fe0c2279a662; Auth-a63f9400-631c-483f-b8aa—-abdccal
75137=31dabbl0ed9f5a4e018cedal30fb536488e84fcde; Auth-dlb4963e-2be7-40ec-b312-a2d2lelefdb5=acdl20595e8d960ac223
582c32cb02578a8dffle; Auth-45b2864e-c3ed-4£f62-b742-6d0d30753d99=4e9f6clba7e42d6d81d5a3d9213420dalab64215; Auth
-a08a9e66-68b7-48a2-ad42-da7c6126a410=913ee7273fda686eabbdba3do9d5e9764clfdc294; Auth-dl19156fd-83£8-43c9-b7c4d-1
85£f0604c384=09e87b695eb225e5c257cab9d7£3810£6065e5af; Auth-255a9ccb-4ceb-4c00-9c2f-17c0c73b2689=469912d63506c5
61ca2c93f40020a421246e30cd; Auth-97315f5e-348f-48b8-9d8b-feB846d316995=934fel4cda99ff0c9434efcb9f7d883c47ceeele
; Auth-0bf6933f-2183-45e5-8291-3a96930058a7=e336e835deaab78f8fbb65c2649a1609d510c7bf; Auth-9céed2lc-2e64-4cf7-
92a4-476bb7£8fal0b=20e47197727073ece49005£031£f731cdfeb8ded8; Auth-57bb8a65-3ab6-4403-bd1f-06639b5d8383=balc7ff2
1db5ae330f4adc47bb6d92044c37c£28; Auth-6eb31f1£f-8£99-40be-b765-430fb85e28£7=78391d5bba852£6b00b080535de8867007
eaa727; Auth-83fb009%a-ede9-40f5-adc7-dfdlecl25f84=8ea449af68f1e3c42589cb75d12deba830b9514a; Auth-9a419303-2005
—4e65-81la7-e6770bcbd83c=0£9c8b24a7e31b77d84d66£2204adbf20abbl4d7; Auth-b323ad09-23ad-4e68-b905-adl414eb9880=24
cae3d5f2631£f23e65ed00330blaad05d5eb9%9a9; Auth-0fddbfed-el4d-49ee-92c8-d2d0d7d4£252=80e8ee59cd32b0b9%d1ed51399%beb
a301d469va7l; Auth-ca282667-0444-4fe7-bb7d-d87£f18be62ce=4d90728d2156843a0752ea640193f6fe80dlad4b; Auth-5d8740d
e-b018-4ad4-951e-2394448£5112=87b54b54acc4145794bb08elc06ad43c06bd8e52; Auth-56936bbe-042f-47ee-8cbd-a95a98f6b
807=d7fc049815a41592b4d9c847b7575efef6d85e06; Auth-7613166d-253f-4393-b95e-879bf00393af=fad49a0d4afl3elbdal37adcO
a5c6ac351dfe30324b; Auth-2ee222a3-7bed-462b-a435-7d4f8b2bc3el1=4£80a0324fblafa8ell454554abd931d69436ee9; Auth-c
175ab26-7d02-4del-9777-7ca23eb091laf=cfad6171c3eca2a88d06801£1704b8326286afal; Auth-09d2c5eb-a373-4166-b508-b50
6b4d85025=c97ec07209c8aacc590ealbf7d8b39f201a30elc; Auth-edd210e8-1786-4690-bf91-a71f95b28a87=8eeb8e59dbf6c694
49cbl02c7fa74d6aal0c367c6; Auth-ccd452a88-all11-49fc-9c0a-e38flbllbff7=15f2fc4009e482ee4e8f06e3eaf0af9e28218c01;
Auth-2551331a-149f-464a-a248-97c8eebalb06=1cd3ade3£fd5d04597fcde2bd0829d8cealalb845; Auth-bdcde70f-9c41-47fc-87
b7-fa49f175d3c4=f0c73319d4efacae9d4fc2b8ed7ec32dea89306b; Auth-34dac442-beal-4d56-a6c2-1ecd7b3220c5=fdf6ede8f4
9da7£f76£3438b6fa6774798b0235e5; Auth-241058f1-97a2-4268-89af-584c53b80d03=0beafd21140ca754288£515799£57d8cec0b
9680; Auth-81df05c5-fbfd4-4ecl-bb00-0ea320b724c0=5a3f94fa41211af2dccd50£0538£968d722622b9; Auth-75860e59-alba-4
b3c-8e7c-27e2fc5dafe5=705¢cc32818524a3d7ae909f85b9d1c8e830d3370; Auth-9e68491a-13cb-4ce3-8f38-abab5c8ce872=£058
73466561371a91675594d£f1529bcff25¢c229; Auth-e75f70b9-678a-4562-8£8c-b86£e31817d6=091£53598cea90313ccd65744c3ef?2
02bl46e534; Auth-329b56f7-85b0-4a2d-ae30-e6£8770960d4=61045402930dd9%ad2339a0a36995a591b8beb6fab; Auth-f63ec3e8—
dc22-4689-adc7-eclaabbca3f2=ec7e50dc483130a52b85de3207aacc7465ee3e5f; Auth-fba9bca6-f141-48cc-8dfc-c5b512£3846
3=295769eclde25bb0b004b951lacbh9bal36c5b2d059; Auth-dc389120-cfal-4923-82a5-e84c5d45cebl=7476a250£0ddff84bl1f3aa5
46625f5fa47d1339; Auth-603fb2bl1-£f8£f9-48be-9251-751a304bdbcd=b835ab6ea5127£942al4bbfdld9%baa9ab34aa5d; Auth-67f
53f5¢c-2033-4dc9-a989-19e3a6ac8f49=d112fdf4033a95ea8a27cf3abbc947ffe6c8a9%4; Auth-e0b01236-9c80-4753-ab74-f42ca
edf7f£d=8873d02127b0a7£7995089f1156a586cc66ce353; Auth-a293007e-6£53-47d8-b706-a4a386684e54=0ddc5470c360966152
c5cf7449955ecbf2b4db49; Auth-93af6dlb-72f7-4e33-alc3-e500e536036e=22b126276£31fac06d9%9ae6d81d30bc997b7e74bf; Au
th-832e09e2-06a6-41a0-897e-134ed92b76b4=cfa3c590cefd306023£53b275e0bffa2e6a03759; Auth-32de6ad48-65c4-4alb-adac
—-ff941556a4c9=acaB864d57f0caed4lalb0eda58e67b873ee84e3fb; Auth-bd5e8538-026d-4af2-9f60-fe9c3d6a5cbd=ecba91c2761b
8lece8c236d05b7cd44a0f3cb2bd; Auth-61£fc9ad9-883c-426c-82e4-075708ale7e3=68529a96e0£9319386cclcd42de83392d8eb429
89; Auth-1d00032e-18d9-4aed-8b2b-82609d06c68a=e486c2ae3e8ae3eallel3ab33d04cced632d5928d; Auth-670ffe31-78cb-451
e-b2a3-£8739f4b33ad=09ad2028e3af03c3b237ad934008b055317035c8; Auth-2b8dd9%ae-4dd5-45e5-bde9-9facl846

#2 - 07/29/2020 03:54 PM - Greg Shah

Is the recreate to use Hotel GUI in virtual desktop mode and to OS login/logout many times until the problem occurs?

#3 - 07/29/2020 04:00 PM - Igor Skornyakov
Greg Shah wrote:

Is the recreate to use Hotel GUI in virtual desktop mode and to OS login/logout many times until the problem occurs?

It is recreated with Hotel GUI. I've used it in virtual desktop mode for the first time (as far as | remember) but the OS Login URL is the same as for the
other application I've logged in to multiple times.
#4 - 10/15/2020 06:08 AM - Greg Shah

From Sergey:

I would like to notify about this issue that today | observed the first time today when testing Hotel_GUI repeatedly within an hour using Firefox
web client.

Finally I got https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/431 and ffter deleting all cookies for the target site, in my cases it was
https://192.168.1.37:7443, the issue was gone.

#5 - 03/09/2021 07:27 AM - Sergey Ivanovskiy
- Status changed from New to WIP

Please review the committed revision 12095 (3821c) that should clear authorization token cookies if the application page is redirected to the login
page. The current page is redirected to the login page if MSG_QUIT is happened or web socket connection is failed. | followed
https://developer.mozilla.org/en-US/docs/Web/APl/Document/cookie

https://stackoverflow.com/questions/179355/clearing-all-cookies-with-javascript

Does it make sense to implement the server side solution by setting response header Clear-Site-Data: "cookies" if the embedded web server is about
to be shutdown since https:/developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Clear-Site-Data warns that Safari doesn't support this header,
Clear-Site-Data?

#6 - 03/09/2021 07:51 AM - Hynek Cihlar
Sergey Ivanovskiy wrote:
Does it make sense to implement the server side solution by setting response header Clear-Site-Data: "cookies" if the embedded web server is

about to be shutdown since https:/developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Clear-Site-Data warns that Safari doesn't support this
header, Clear-Site-Data?

Beware that there are cookies we want to keep after the session ends. I'm aware of the GUI renderer options set by the user for example.

#7 - 03/09/2021 11:34 AM - Sergey Ivanovskiy

Yes, | didn't observe that cookies with these keys "renderer" and "graphicsCached" should be persistent. These changes rev 12096(3821c) should
help to remove only cookies with authorization tokens. Their keys start with "auth-".

#8 - 03/09/2021 05:25 PM - Hynek Cihlar

Sergey Ivanovskiy wrote:

Yes, | didn't observe that cookies with these keys "renderer" and "graphicsCached" should be persistent. These changes rev 12096(3821c)
should help to remove only cookies with authorization tokens. Their keys start with "auth-".
https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/431
https://192.168.1.37:7443
https://developer.mozilla.org/en-US/docs/Web/API/Document/cookie
https://stackoverflow.com/questions/179355/clearing-all-cookies-with-javascript
https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Clear-Site-Data
https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Clear-Site-Data

Sergey, the changes are OK. Just please replace if (key.substring(0, 4).toLowerCase() == "auth-") with a different construct to prevent unexpected
IndexOutOfBoundsException.

#9 - 03/10/2021 04:01 AM - Sergey Ivanovskiy

It seems that substring(indexStart, indexEnd) is safe and doesn't throw index out of bound exception. MDN said that if the second index is more than
the string length, then it is treated as it is equal to the string length.
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/substring

#10 - 03/10/2021 04:04 AM - Sergey Ivanovskiy

| changed this condition if (key.substring(0, 4).toLowerCase() = = "auth-") to if (key.substring(0, 5).toLowerCase() == "auth-") in the rev 12097(3821c)
because indexEnd is an exclusive index.

#11 - 03/10/2021 04:07 AM - Sergey Ivanovskiy

The ECMA 262 specification https://tc39.es/ecma262/#sec-string.prototype.substring also states the same specification for substring as its MDN doc.

#12 - 03/10/2021 05:13 AM - Hynek Cihlar
Sergey Ivanovskiy wrote:
It seems that substring(indexStart, indexEnd) is safe and doesn't throw index out of bound exception. MDN said that if the second index is more

than the string length, then it is treated as it is equal to the string length.
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/substring

Right, this is JS not Java :-).

#13 - 03/10/2021 05:13 AM - Hynek Cihlar

Sergey Ivanovskiy wrote:

| changed this condition if (key.substring(0, 4).toLowerCase() = = "auth-") to if (key.substring(0, 5).toLowerCase() == "auth-") in the rev
12097(3821c¢) because indexEnd is an exclusive index.

The changes are OK.

#14 - 03/10/2021 08:27 AM - Greg Shah
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/substring
https://tc39.es/ecma262/#sec-string.prototype.substring
- Start date deleted (07/29/2020)
- Status changed from WIP to Closed
- Assignee set to Sergey Ivanovskiy

- % Done changed from 0 to 100
